using System;
using System.ComponentModel;
using System.Drawing;
using System.Windows.Forms;

namespace Graphix
{
	public class formMain : Form
	{
		private Button exitButton;
		private GroupBox groupBox1;
		private Label label1;
		private RadioButton radioButton1;
		private Label label2;
		private RadioButton radioButton2;
		private ComboBox cbBody;
		private Container components = null;

        Graphics gr;
        Figure cF; //  
	    
        float dx, dy;             //   
        bool isPressed = false;   //    ?	    
	    
		public formMain()
		{
			InitializeComponent();
		}

		protected override void Dispose( bool disposing )
		{
			if( disposing )
			{
				if (components != null) 
				{
					components.Dispose();
				}
			}
			base.Dispose( disposing );
		}

		#region Windows Form Designer generated code

		private void InitializeComponent()
		{
            this.exitButton = new System.Windows.Forms.Button();
            this.groupBox1 = new System.Windows.Forms.GroupBox();
            this.radioButton2 = new System.Windows.Forms.RadioButton();
            this.label2 = new System.Windows.Forms.Label();
            this.radioButton1 = new System.Windows.Forms.RadioButton();
            this.label1 = new System.Windows.Forms.Label();
            this.cbBody = new System.Windows.Forms.ComboBox();
            this.groupBox1.SuspendLayout();
            this.SuspendLayout();
            // 
            // exitButton
            // 
            this.exitButton.Location = new System.Drawing.Point(408, 272);
            this.exitButton.Name = "exitButton";
            this.exitButton.Size = new System.Drawing.Size(72, 32);
            this.exitButton.TabIndex = 0;
            this.exitButton.Text = "";
            this.exitButton.Click += new System.EventHandler(this.exitButton_Click);
            // 
            // groupBox1
            // 
            this.groupBox1.Controls.Add(this.radioButton2);
            this.groupBox1.Controls.Add(this.label2);
            this.groupBox1.Controls.Add(this.radioButton1);
            this.groupBox1.Controls.Add(this.label1);
            this.groupBox1.Controls.Add(this.cbBody);
            this.groupBox1.Location = new System.Drawing.Point(328, 8);
            this.groupBox1.Name = "groupBox1";
            this.groupBox1.Size = new System.Drawing.Size(152, 256);
            this.groupBox1.TabIndex = 1;
            this.groupBox1.TabStop = false;
            this.groupBox1.Text = "";
            // 
            // radioButton2
            // 
            this.radioButton2.Location = new System.Drawing.Point(10, 120);
            this.radioButton2.Name = "radioButton2";
            this.radioButton2.Size = new System.Drawing.Size(134, 32);
            this.radioButton2.TabIndex = 4;
            this.radioButton2.Text = " / ";
            // 
            // label2
            // 
            this.label2.Location = new System.Drawing.Point(8, 80);
            this.label2.Name = "label2";
            this.label2.Size = new System.Drawing.Size(120, 16);
            this.label2.TabIndex = 3;
            this.label2.Text = ":";
            // 
            // radioButton1
            // 
            this.radioButton1.Checked = true;
            this.radioButton1.Location = new System.Drawing.Point(10, 104);
            this.radioButton1.Name = "radioButton1";
            this.radioButton1.Size = new System.Drawing.Size(120, 16);
            this.radioButton1.TabIndex = 2;
            this.radioButton1.TabStop = true;
            this.radioButton1.Text = "";
            // 
            // label1
            // 
            this.label1.Location = new System.Drawing.Point(8, 20);
            this.label1.Name = "label1";
            this.label1.Size = new System.Drawing.Size(136, 16);
            this.label1.TabIndex = 1;
            this.label1.Text = " :";
            // 
            // cbBody
            // 
            this.cbBody.DropDownStyle = System.Windows.Forms.ComboBoxStyle.DropDownList;
            this.cbBody.Items.AddRange(new object[] {
            " ",
            "",
            "",
            "",
            ""});
            this.cbBody.Location = new System.Drawing.Point(10, 40);
            this.cbBody.Name = "cbBody";
            this.cbBody.Size = new System.Drawing.Size(134, 21);
            this.cbBody.TabIndex = 0;
            this.cbBody.SelectedIndexChanged += new System.EventHandler(this.cbBody_SelectedIndexChanged);
            // 
            // formMain
            // 
            this.AutoScaleBaseSize = new System.Drawing.Size(5, 13);
            this.ClientSize = new System.Drawing.Size(494, 318);
            this.Controls.Add(this.groupBox1);
            this.Controls.Add(this.exitButton);
            this.FormBorderStyle = System.Windows.Forms.FormBorderStyle.FixedDialog;
            this.MaximizeBox = false;
            this.Name = "formMain";
            this.StartPosition = System.Windows.Forms.FormStartPosition.CenterScreen;
            this.Text = "  ";
            this.MouseWheel += new System.Windows.Forms.MouseEventHandler(this.formMain_MouseWheel);
            this.Paint += new System.Windows.Forms.PaintEventHandler(this.formMain_Paint);
            this.MouseUp += new System.Windows.Forms.MouseEventHandler(this.formMain_MouseUp);
            this.MouseMove += new System.Windows.Forms.MouseEventHandler(this.formMain_MouseMove);
            this.MouseDown += new System.Windows.Forms.MouseEventHandler(this.formMain_MouseDown);
            this.Load += new System.EventHandler(this.formMain_Load);
            this.groupBox1.ResumeLayout(false);
            this.ResumeLayout(false);

		}
		#endregion

		[STAThread]

		static void Main() 
		{
			Application.Run(new formMain());
		}

		public class Figure
		{
			public float[,] Coords;
			protected float[,] matrix = new float[4, 4];

			public Figure() //   
			{
				Coords = new float[,]
				{
					{69, -83, 0, 1},
					{74, 0, -91, 1},
					{25, 87, 39, 1},
					{-69, 18, 25, 1},
				};
			}

			public Figure(Figure existingFigure) //  
			{
				Coords = existingFigure.Coords;
			}

			protected void EraseMatrix(float[,] m) //   
			{
				for(int i = 0; i < m.GetLength(0); i++)
					for(int j = 0; j < m.GetLength(1); j++)
						m[i, j] = 0;
			}

			protected float[,] MultiplyMatrix(float[,] m1, float[,] m2) //   
			{
				float[,] mt = new float[m1.GetLength(0), m2.GetLength(1)];
				int i, j, k;
				for(i = 0; i < m1.GetLength(0); i++)
					for(j = 0; j < m1.GetLength(1); j++)
					{
						mt[i, j] = 0;
						for(k = 0; k < m2.GetLength(0); k++)
							mt[i, j] += m1[i, k] * m2[k, j];
					}
                return mt;
			}

			public void Rotate(float rx, float ry, float rz) // 
			{
				if(rx != 0) // ,   y
				{
					EraseMatrix(matrix);
					matrix[0, 0] = (float) Math.Cos(rx);
					matrix[0, 2] = (float) -Math.Sin(rx);
					matrix[1, 1] = 1;
					matrix[2, 0] = (float) Math.Sin(rx);
					matrix[2, 2] = (float) Math.Cos(rx);
					matrix[3, 3] = 1;
					Coords = MultiplyMatrix(Coords, matrix);
				}
				if(ry != 0) // ,   x
				{
					EraseMatrix(matrix);
					matrix[0, 0] = 1;
					matrix[1, 1] = (float) Math.Cos(ry);
					matrix[1, 2] = (float) Math.Sin(ry);
					matrix[2, 1] = (float) -Math.Sin(ry);
					matrix[2, 2] = (float) Math.Cos(ry);
					matrix[3, 3] = 1;
                    Coords = MultiplyMatrix(Coords, matrix);
				}
				if(rz != 0) // ,   z
				{
					EraseMatrix(matrix);
					matrix[0, 0] = (float) Math.Cos(rz);
					matrix[0, 1] = (float) Math.Sin(rz);
					matrix[1, 0] = (float) -Math.Sin(rz);
					matrix[1, 1] = (float) Math.Cos(rz);
					matrix[2, 2] = 1;
					matrix[3, 3] = 1;
                    Coords = MultiplyMatrix(Coords, matrix);
				}
			}
			
			public void Move(float mx, float my) // 
			{
				EraseMatrix(matrix);
				for(int i = 0; i < 4; i++) matrix[i, i] = 1;
				matrix[3, 0] = mx;
				matrix[3, 1] = my;
                Coords = MultiplyMatrix(Coords, matrix);
			}
			
			public void Scale(float sz) // 
			{
				EraseMatrix(matrix);
				for(int i = 0; i < 4; i++) matrix[i, i] = sz;
				matrix[3, 0] = 1;
                Coords = MultiplyMatrix(Coords, matrix);
			}

			public virtual void Draw(Graphics rgr, Color theColor) //  
			{
				const float c = 150;
				Pen thePen = new Pen(theColor);
				for(int i = 0; i < Coords.GetLength(0); i++)
					for(int j = i + 1; j < Coords.GetLength(0); j++) 
						rgr.DrawLine(thePen, Coords[i, 0] + c, Coords[i, 1] + c, Coords[j, 0] + c, Coords[j, 1] + c);
			}
		}

		public class Tetrahedron : Figure // - 
		{
			public Tetrahedron()
			{
				Coords = new float[,] 
				{
					{-26, 97, 0, 1},
					{-71, -71, 0, 1},
					{97, -26, 0, 1},
					{0, 0, 141, 1}
				};
			}
		}

		public class Octahedron : Figure // - 
		{
			public Octahedron()
			{
				Coords = new float[,] 
				{
					{18, 69, 0, 1},	
					{69, -18, 0, 1},
					{0, 0, -71, 1},
					{-18, -69, 0, 1},
					{-69, 18, 0, 1},
					{0, 0, 71, 1} 
				};
			}

			public override void Draw(Graphics rgr, Color theColor) //   
			{
				const float c = 150;
				Pen thePen = new Pen(theColor);
				for(int i = 0; i < Coords.GetLength(0); i++)
					for(int j = i; j < Coords.GetLength(0); j++) 
						if(j - i != 3) rgr.DrawLine(thePen, Coords[i, 0] + c, Coords[i, 1] + c, Coords[j, 0] + c, Coords[j, 1] + c);
			}
		}

		public class Hexahedron : Figure // -  ()
		{
			public Hexahedron()
			{
				Coords = new float[,] 
				{
					{18, 54, 66, 1},
					{-69, 30, -44, 1},
					{69, -4, -53, 1},
					{-18, -80, 30, 1},
					{69, -30, 44, 1},
					{-18, -54, -66, 1},
					{18, 80, -30, 1},
					{-69, 4, 53, 1}
				};
			}
			public override void Draw(Graphics rgr, Color theColor) //   
			{
				const float c = 150;
				Pen thePen = new Pen(theColor);
				rgr.DrawLine(thePen, Coords[0, 0] + c, Coords[0, 1] + c, Coords[4, 0] + c, Coords[4, 1] + c);
				rgr.DrawLine(thePen, Coords[0, 0] + c, Coords[0, 1] + c, Coords[6, 0] + c, Coords[6, 1] + c);
				rgr.DrawLine(thePen, Coords[0, 0] + c, Coords[0, 1] + c, Coords[7, 0] + c, Coords[7, 1] + c);
				rgr.DrawLine(thePen, Coords[1, 0] + c, Coords[1, 1] + c, Coords[5, 0] + c, Coords[5, 1] + c);
				rgr.DrawLine(thePen, Coords[1, 0] + c, Coords[1, 1] + c, Coords[6, 0] + c, Coords[6, 1] + c);
				rgr.DrawLine(thePen, Coords[1, 0] + c, Coords[1, 1] + c, Coords[7, 0] + c, Coords[7, 1] + c);
				rgr.DrawLine(thePen, Coords[2, 0] + c, Coords[2, 1] + c, Coords[4, 0] + c, Coords[4, 1] + c);
				rgr.DrawLine(thePen, Coords[2, 0] + c, Coords[2, 1] + c, Coords[5, 0] + c, Coords[5, 1] + c);
				rgr.DrawLine(thePen, Coords[2, 0] + c, Coords[2, 1] + c, Coords[6, 0] + c, Coords[6, 1] + c);
				rgr.DrawLine(thePen, Coords[3, 0] + c, Coords[3, 1] + c, Coords[4, 0] + c, Coords[4, 1] + c);
				rgr.DrawLine(thePen, Coords[3, 0] + c, Coords[3, 1] + c, Coords[5, 0] + c, Coords[5, 1] + c);
				rgr.DrawLine(thePen, Coords[3, 0] + c, Coords[3, 1] + c, Coords[7, 0] + c, Coords[7, 1] + c);
			}
		}

		public class Icosahedron : Figure // - 
		{
			public Icosahedron()
			{
				Coords = new float[,] 
				{
					{0, 120, 0, 1},
					{114.12F, 60, -37.08F, 1},
					{70.44F, 60, 97.08F, 1},
					{-70.44F, 60, 97.08F, 1},
					{-114.12F, 60, -37.08F, 1},
					{0, 60, -120, 1},
					{114.12F, -60, 37.08F, 1},
					{0, -60, 120, 1},
					{-114.12F, -60, 37.08F, 1},
					{-70.44F, -60, -97.08F, 1},
					{70.44F, -60, -97.08F, 1},
					{0, -120, 0, 1}
				};
			}
			public override void Draw(Graphics rgr, Color theColor) //   
			{
				const float c = 150;
				Pen thePen = new Pen(theColor);
				int ex = 5, ex2 = 0;
				for(int i = 1; i < 6; i++)
				{
					if(i == 2) ex = 0;
					if(i == 5) ex2 = 5;
					rgr.DrawLine(thePen, Coords[0, 0] + c, Coords[0, 1] + c, Coords[i, 0] + c, Coords[i, 1] + c);
					rgr.DrawLine(thePen, Coords[i, 0] + c, Coords[i, 1] + c, Coords[i + 1 - ex2, 0] + c, Coords[i + 1 - ex2, 1] + c);
					rgr.DrawLine(thePen, Coords[i, 0] + c, Coords[i, 1] + c, Coords[i + 4 + ex, 0] + c, Coords[i + 4 + ex, 1] + c);
					rgr.DrawLine(thePen, Coords[i, 0] + c, Coords[i, 1] + c, Coords[i + 5, 0] + c, Coords[i + 5, 1] + c);
					rgr.DrawLine(thePen, Coords[i + 4 + ex, 0] + c, Coords[i + 4 + ex, 1] + c, Coords[i + 5, 0] + c, Coords[i + 5, 1] + c);
					rgr.DrawLine(thePen, Coords[11, 0] + c, Coords[11, 1] + c, Coords[i + 4 + ex, 0] + c, Coords[i + 4 + ex, 1] + c);
				}
			}
		}
		
		private void formMain_MouseDown(object sender, MouseEventArgs e)
		{
			exitButton.Focus();
			isPressed = true;
			dx = e.X; // 
			dy = e.Y;
		}

		private void formMain_MouseMove(object sender, MouseEventArgs e)
		{
			if(isPressed)
			{
				float nx, ny; // 
				nx = dx - e.X;
				ny = -dy + e.Y;
				dx = e.X;
				dy = e.Y;
				cF.Draw(gr, Color.White);
				if(radioButton1.Checked) cF.Rotate(nx / 60, ny / 60, 0);
				if(radioButton2.Checked) cF.Move(-nx, ny);
				cF.Draw(gr, Color.Black);
			}
		}

		private void formMain_MouseUp(object sender, MouseEventArgs e)
		{
			isPressed = false;
		}
		
		private void formMain_MouseWheel(object sender, MouseEventArgs e)
		{
			float nz;
			nz = e.Delta / 20;
			cF.Draw(gr, Color.White);
			if(radioButton1.Checked) cF.Rotate(0, 0, nz);
			if(radioButton2.Checked) cF.Scale((float) Math.Pow(Math.E, nz / 40));
			cF.Draw(gr, Color.Black);
		}

		private void formMain_Paint(object sender, PaintEventArgs e)
		{
            gr.FillRectangle(Brushes.White, 10, 10, 300, 300);
			cF.Draw(e.Graphics, Color.Black);
		}

        private void exitButton_Click(object sender, EventArgs e)
		{
			Close();
		}

		private void cbBody_SelectedIndexChanged(object sender, EventArgs e)
		{
			switch(cbBody.Text)
			{
				case " ": cF = new Figure(); break;
				case "": cF = new Tetrahedron(); break;
				case "" : cF = new Octahedron(); break;
				case "": cF = new Hexahedron(); break;
				case "": cF = new Icosahedron(); break;
			}
            gr.FillRectangle(Brushes.White, 10, 10, 300, 300);
			cF.Draw(gr, Color.Black);
		}

        private void formMain_Load(object sender, EventArgs e)
        {
            gr = CreateGraphics();            
            gr.Clip = new Region(new Rectangle(10, 10, 300, 300));            
            cF = new Figure();
        }
	}
}